/*
  Scrivere un programma che legga una stringa da tastiera e stampi uno tra i 
  bigrammi più frequenti contenuti in tale stringa e la sua frequenza.

  Bigramma = coppia di caratteri consecutivi

  Usare una matrice bidimensionale 256x256 dove memorizzare le frequenze dei bigrammi.

  Assumere che la stringa in input consista di al più 1000 caratteri.

  Esempio:
  pazzapezzapizzapozzapuzza

  “zz” e “za”  sono i bigrammi più frequenti. Il programma deve stampare uno 
  di questi e la sua frequenza 5.
  
  E' conveniente usare il tipo unsigned char anziché char così da poter direttamente 
  indicizzare l'array bidimensionale.
*/

#include <stdlib.h>
#include <stdio.h>

#define ALFABETO (256)
#define MAXLEN (1000)

/* Inizializza gli elementi della matrice delle frequenze a 0 */
void init(int freqs[][ALFABETO]) {
  
  int r, c;

  for ( r = 0; r < ALFABETO; r++ )
      for ( c = 0; c < ALFABETO; c++ )
	  freqs[r][c] = 0;

}


/* Conta le frequenze dei bigrammi contenuti in s */
void conta(unsigned char *str, int freqs[][ALFABETO]) {
    
  int r, c;

  init(freqs); // inizializza la matrice
  
  /* Scorriamo la stringa fino all'ultimo bigramma. Contiamo la frequenza di ciascun 
     bigramma xy incrementando il contatore in frequenze[x][y] */
  for (; *(str+1) != '\0'; str++)     
      freqs[*str][*(str+1)]++;
}


/* 
   Scrive in b il bigramma di frequenza massima e in *max la sua frequenzalo 
   e in scrive in b[] 
*/
void max_freq(int freqs[][ALFABETO], unsigned char b[], int * max) {
  
  int r, c; 
  
  *max = 0;
  for ( r = 0; r < ALFABETO; r++ )
      for ( c = 0; c < ALFABETO; c++ ) 
	  if ( freqs[r][c] > *max ) {
	      *max = freqs[r][c];
	      b[0] = r; b[1] = c; // scrive massimo corrente in b
	  }  

}


int main(){

  int frequenze[256][256];  // array di contatori per tenere traccia delle frequenze 
  int i = 0, max;
  unsigned char s[MAXLEN +1], b[3] = "XX";  // b conterrà l'output
  
  while((i < MAXLEN) && ((s[i++] = getchar()) != '\n')) // alternativa a scanf("%s", s); Si legge la stringa carattere per carattere fino al primo '\n'
  ;  
  s[i] = '\0'; // la stringa è lunga i caratteri.

  conta(s, frequenze);
  max_freq(frequenze, b, &max);

  printf("%s %d\n", b, max);

  return 0;
 
}

